#
# Ronin Exploits - A Ruby library for Ronin that provides exploitation and
# payload crafting functionality.
#
# Copyright (c) 2007-2009 Hal Brodigan (postmodern.mod3 at gmail.com)
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#

require 'ronin/exploits/exceptions/target_data_missing'
require 'ronin/formatting/binary'

module Ronin
  module Exploits
    module Helpers
      module Binary
        #
        # Packs an integer using the current targeted architecture
        # and the address-length.
        #
        # @param [Integer] integer
        #   The integer to pack.
        #
        # @param [Integer] address_length
        #   The address-length to pack the integer into.
        #
        # @return [String]
        #   The packed integer.
        #
        def pack(integer,address_length=nil)
          verify_arch!

          return integer.pack(arch,(address_length || arch.address_length))
        end
      end
    end
  end
end
