require 'ronin/generators/payloads/binary_payload'
require 'ronin/payloads/binary_payload'

require 'spec_helper'
require 'generators/payloads/payload_examples'

require 'tmpdir'
require 'fileutils'

describe Generators::Payloads::BinaryPayload do
  before(:all) do
    @path = File.join(Dir.tmpdir,'generated_payload.rb')

    Generators::Payloads::BinaryPayload.generate(
      {},
      [@path]
    )

    @payload = Payloads::BinaryPayload.load_from(@path)
  end

  it_should_behave_like "a Payload"

  it "should define a BinaryPayload" do
    @payload.class.should == Payloads::BinaryPayload
  end

  after(:all) do
    FileUtils.rm(@path)
  end
end
