require 'ronin/model/targets_product'

require 'spec_helper'
require 'model/models/targets_product_model'

describe Model::TargetsArch do
  it "should define a product relation" do
    relationship = TargetsProductModel.relationships['product']

    relationship.should_not be_nil
    relationship.parent_model.should == Product
  end

  it "should define a relationship with Product" do
    relationship = Product.relationships['targets_product_models']

    relationship.should_not be_nil
    relationship.child_model.should == TargetsProductModel
  end

  it "should provide access to the targeted product" do
    model = TargetsProductModel.new(
      :product => Product.new(:name => 'Toaster')
    )

    model.product.name.should == 'Toaster'
  end

  it "should allow the product to be set via the getter method" do
    model = TargetsProductModel.new
    model.product :name => 'Toaster'

    model.product.name.should == 'Toaster'
  end
end
